//
// SourceMod Script
//
// Developed by <eVa>Dog
// June 2008
// http://www.theville.org
//

//
// DESCRIPTION:
// For Day of Defeat Source only
// This plugin changes losing teams into random objects
// at Round End, to help them escape from the enemy
//
// CHANGELOG:
// See SourceMod forums for changelog



#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.09SM"
#define MAXMODELS 45

new Handle:Cvar_ThirdPerson = INVALID_HANDLE

new g_maxplayers
new g_AxisModel
new g_AlliedModel
new g_bonus = 0

//Create the bonus round models
new String: g_modelname[][] = {
    "models/props_foliage/shrub_01a.mdl",
    "models/props_foliage/flower_barrel.mdl",
    "models/props_furniture/table1.mdl",
    "models/props_crates/static_crate_64.mdl",
    "models/props_crates/woodbarrel001.mdl",
    "models/props_italian/wagon.mdl",
    "models/props_urban/phonepole1.mdl",
    "models/props_foliage/pot_big.mdl",
    "models/props_fortifications/sandbags_corner1.mdl",
    "models/props_fortifications/dragonsteeth_large.mdl",
    "models/props_foliage/hedge_small.mdl",
    "models/props_misc/well-1.mdl",
    "models/props_foliage/rock_coast02c.mdl",
    "models/props_foliage/rock_riverbed02c.mdl",
    "models/props_foliage/tree_pine_01.mdl",
    "models/props_furniture/chairantique.mdl",
    "models/props_normandy/haybale.mdl",
    "models/props_misc/claypot02.mdl",
    "models/props_foliage/cattails.mdl",
    "models/props_foliage/shrub_small.mdl",
    "models/props_fortifications/hedgehog_small1.mdl",
    "models/props_furniture/dresser1.mdl",
    "models/props_urban/bench_wood.mdl",
    "models/props_foliage/tree_deciduous_01a.mdl",
    "models/props_italian/boat_wooden03a.mdl",
    "models/props_italian/anzio_market_table1.mdl",
    "models/props_italian/anzio_fountain.mdl",
    "models/props_fortifications/sandbags_line2_tall.mdl",
    "models/props_furniture/bathtub1.mdl",
    "models/props_furniture/cafe_barstool.mdl",
    "models/props_furniture/inn_mailbox1.mdl",
    "models/props_furniture/kitchen_oven1.mdl",
    "models/props_furniture/piano.mdl",
    "models/props_furniture/toilet1.mdl",
    "models/props_doors/dod_door1.mdl",
    "models/props_doors/dod_door2.mdl",
    "models/props_misc/lamp-1.mdl",
    "models/props_misc/claypot02.mdl",
    "models/props_normandy/logpile.mdl",
    "models/props_fortifications/fueldrum.mdl",
    "models/props_fortifications/flak38.mdl",
    "models/props_misc/sewer_entrance-2.mdl",
    "models/props_foliage/tree_pine_cluster_01.mdl",
    "models/props_foliage/vine_wall1.mdl",
    "models/props_urban/lights_streetlight01_on.mdl"
    }

new String:g_modeltext[][] = {
    "Shrub",
    "Flower barrel",
    "Table",
    "Crate",
    "Wooden barrel",
    "Wagon",
    "Phone pole",
    "Big flower pot",
    "Sandbags curved",
    "Concrete block",
    "Hedge",
    "Well",
    "Rock",
    "Group of rocks",
    "Pine tree",
    "Chair",
    "Hay bale",
    "Pot",
    "Cattails",
    "Small shrub",
    "Hedgehog",
    "Dresser",
    "Bench",
    "Deciduous tree",
    "Boat",
    "Market table",
    "Fountain",
    "Sandbags straight",
    "Bathtub",
    "Cafe Barstool",
    "Inn Mailbox",
    "Kitchen Oven",
    "Piano",
    "Toilet",
    "White Door",
    "Brown Door",
    "Lamp",
    "Clay Pot",
    "Log Pile",
    "Fuel Drum",
    "Flak 38 Anti-Aircraft Gun",
    "Sewer Entrance",
    "Pine Tree Cluster",
    "Wall with Vines",
    "Street Light"
    }
    
new g_modelindex[MAXMODELS + 1]

public Plugin:myinfo =
{
    name = "Dog's Bonus Round",
    author = "<eVa>Dog",
    description = "The losing team turn into different models to hide during the bonus round!",
    version = PLUGIN_VERSION,
    url = "http://www.theville.org"
}

public OnPluginStart()
{
    CreateConVar("dog_bonus_round", PLUGIN_VERSION, "Version of dog_bonus_round", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY)
    Cvar_ThirdPerson = CreateConVar("sv_bonus_round_third_person", "0", "When enabled, losing players go into 3rd person mode", FCVAR_PLUGIN)
    
    HookEvent("dod_round_start", PlayerStartEvent)
    HookEvent("dod_round_win", PlayerRoundWinEvent)
    HookEvent("player_hurt", Event_PlayerHurt, EventHookMode_Pre)
}

public OnMapStart()
{
    for (new i = 0; i < MAXMODELS; i++)
    {
        g_modelindex[i] = PrecacheModel(g_modelname[i], true)
        PrintToServer("Cached: %s with number %i", g_modelname[i], g_modelindex[i])
    }
    
    g_AxisModel = PrecacheModel("models/player/german_support.mdl", true)
    g_AlliedModel = PrecacheModel("models/player/american_support.mdl", true)
}

public OnEventShutdown()
{
    UnhookEvent("dod_round_win", PlayerRoundWinEvent)
    UnhookEvent("player_hurt", Event_PlayerHurt)
    UnhookEvent("dod_round_start", PlayerStartEvent)
}

public Action:PlayerStartEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
    g_bonus = 0
}

public Action:Event_PlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
    if (g_bonus)
    {
        new client = GetClientOfUserId(GetEventInt(event, "userid"))
        new team = GetClientTeam(client)
                    
        new offset = FindSendPropOffs("CBaseEntity", "m_nModelIndex")
        
        if (team == 2)
        {
            GivePlayerItem(client, "weapon_colt")
            SetEntData(client, offset, g_AlliedModel, 4, true)
        }
        if (team == 3)
        {
            GivePlayerItem(client, "weapon_p38")
            SetEntData(client, offset, g_AxisModel, 4, true)
        }    
        SetEntityRenderColor(client, 255, 255, 255, 255)
    }
    return Plugin_Continue
}

public PlayerRoundWinEvent(Handle:event, const String:name[], bool:dontBroadcast)
{
    new winners = GetEventInt(event, "team")
    g_maxplayers = GetClientCount(true)
    new choice
    new offset
    new slot
    new weaponslot
    
    g_bonus = 1
    
    for (new i=1; i <= g_maxplayers; i++)
    {
        if (IsClientInGame(i) && (GetClientTeam(i) != winners) && (IsPlayerAlive(i)))
        {
            for(slot = 0; slot < 5; slot++)
            {
                weaponslot = GetPlayerWeaponSlot(i, slot)
                if (weaponslot != -1)
                {
                    RemovePlayerItem(i, weaponslot)
                }
            }
            
            choice = GetRandomInt(0, MAXMODELS - 1)

            offset = FindSendPropOffs("CBaseEntity", "m_nModelIndex");
            SetEntData(i, offset, g_modelindex[choice], 4, true)
            SetEntityRenderColor(i, 255, 255, 255, 255)
            PrintToChat(i,"\x01You are now a \x04%s \x01so HIDE!", g_modeltext[choice])
            
            if (GetConVarInt(Cvar_ThirdPerson))
            {
                new offset1 = FindSendPropOffs("CBasePlayer", "m_hObserverTarget");
                SetEntDataEnt2(i, offset1, 0, true)
        
                new offset2 = FindSendPropOffs("CBasePlayer", "m_iObserverMode");
                SetEntData(i, offset2, 1, 4, true)
                
                new offset3 = FindSendPropInfo("CBasePlayer", "m_bDrawViewmodel");
                SetEntData(i, offset3, 0, 4, true)
                
                new offset4 = FindSendPropOffs("CBasePlayer", "m_iFOV");
                SetEntData(i, offset4, 120, 4, true)
            }
        }
    }
}